Summary: EDX/UNX Virtual Machine
Name: edx
Version: 1.1.15
Release: 1%{dist}
License: Commercial
Group: System Environment/Base
Source: edx-%{version}.tar.gz
Source1: btree2.edx
BuildRoot: /var/tmp/%{name}-root
BuildRequires: libbms-devel >= 1.1.0 libb++-devel >= 3.0 btas-devel
BuildRequires: edx-asm >= 1.2 /usr/bin/lex ncurses-devel flex-devel 
Conflicts: bmsi-edx < 1.2
Requires: btas >= 2.10.5 nc edx = %{version}-%{release}

%description
EDX Virtual Machine

%package devel
Summary: EDX Program development utilities
Group: Development/Libraries
# FIXME: ksh required for ecc, should be fixed to work with bash
Requires: btas edx-asm >= 1.2 ksh

%description devel
Headers, libraries, and utilities needed to develop EDX applications.

%prep
%setup -q

%build
mkdir -p lib
SRC=. make CPPFLAGS="-pipe -I/usr/include/btas"
# build user interface programs
cd edxui
#make all CPPFLAGS="-DOLDSTL" LDFLAGS="-s -L../lib -L/bms/lib"
make all LDFLAGS="-s -L../lib -L/bms/lib" CPPFLAGS="-I/usr/include/btas"
cd -
# build EDX linker and source preprocessor
cd edxlink
make LDFLAGS="-s -L../lib -L/bms/lib" all CPPFLAGS="-I/usr/include/btas"
cd -
# build EDX BTAS/1 emulator
cd bmsedx
make edxbtas LDFLAGS="-s -L../lib -L/bms/lib"
ln ../edxjob.sh ../edxjob
cd -
export PATH=$PWD:$PWD/edxlink:$PATH
# Prebuilt 
#cd bmsedx
# ecc -I../copycd -o btree2.edx btree2.e
#cd -
cp %{SOURCE1} bmsedx

%install
SRC=. make bindir=%{buildroot}/bms/bin/edx install

mkdir -p %{buildroot}/var/log/edx
ln -sf /var/log/edx %{buildroot}/edx

mkdir -p %{buildroot}/bms/fbin
cat >%{buildroot}/bms/fbin/edcd <<'EOF'
edcd() {
case "$1" in
"")     ;;
/*)     export EDXDIR=$1;;
*)      export EDXDIR=/edx/$1;;
esac
echo $EDXDIR
}
EOF

mkdir -p %{buildroot}/bms/lib
cp -p lib/libedx.a lib/libedxrt.a %{buildroot}/bms/lib

mkdir -p %{buildroot}/bms/include
cp -p vtab.h %{buildroot}/bms/include

for i in edxjob edxstop edxstart qmap cpedx ecc edxlp edxgrab
do
  cp -p $i.sh %{buildroot}/bms/bin/edx/$i
done

for i in edxbms edxdb awcmed edximg; do
  cp -p edxui/$i %{buildroot}/bms/bin/edx/$i
done

for i in edxc edxlink edxstring edxident edxsym edltr utequ; do
  cp -p edxlink/$i %{buildroot}/bms/bin/edx/$i
done

cp -p bmsedx/edxbtas %{buildroot}/bms/bin/edx

mkdir -p %{buildroot}/bms/edx/mslib
cp -p %{SOURCE1} %{buildroot}/bms/edx/mslib
cp -p %{SOURCE1} %{buildroot}/bms/edx/mslib/\$btree.edx

mkdir -p %{buildroot}/bms/edx/asm
cp -p asm/* %{buildroot}/bms/edx/asm

mkdir -p %{buildroot}/bms/edx/copycd
cp -p copycd/* %{buildroot}/bms/edx/copycd

mkdir -p %{buildroot}/bms/etc/printers
cp -p runedx.conf %{buildroot}/bms/etc

mkdir -p %{buildroot}/etc/logrotate.d
cp -p edx.logrotate %{buildroot}/etc/logrotate.d/edx

cd %{buildroot}/bms/bin/edx
ln edxbms edx4978
cd -

mkdir -p %{buildroot}/bms/edx/lib
cp -p user.lnk %{buildroot}/bms/edx/lib/user

mkdir -p %{buildroot}/bms/sbin
cp -p killtty.sh %{buildroot}/bms/sbin/killtty
cp -p ckproc.sh %{buildroot}/bms/sbin/ckproc

cp -p edl.vim %{buildroot}/bms/edx

mkdir -p %{buildroot}/etc/sudoers.d
cp -p edx.sudo %{buildroot}/etc/sudoers.d/edx


%pre
/usr/sbin/useradd -u 701 -g bms -d /edx -r edx >/dev/null 2>&1 || :

%files
%defattr(-,edx,bms)
/bms/bin/edx/diskut1
/bms/bin/edx/diskut2
%attr(4755,edx,bms)/bms/bin/edx/edx
%attr(4755,edx,bms)/bms/bin/edx/edx4974
%attr(4755,edx,bms)/bms/bin/edx/edx4978
%attr(4755,edx,bms)/bms/bin/edx/edxbms
%attr(4755,edx,bms)/bms/bin/edx/edxdb
%attr(6755,edx,bms)/bms/bin/edx/edxbtas
%attr(2755,edx,bms)/bms/bin/edx/awcmed
/bms/bin/edx/edxc
/bms/bin/edx/edxident
/bms/bin/edx/edxjob
/bms/bin/edx/qmap
/bms/bin/edx/edximg
/bms/bin/edx/cpedx
/bms/bin/edx/edxlp
/bms/bin/edx/edxgrab
/bms/fbin/edcd
%attr(4755,edx,bms)/bms/bin/edx/edxmap
%attr(4755,root,root)/bms/bin/edx/edxnuc
%attr(4755,edx,bms)/bms/bin/edx/edxnuc.x
%attr(4755,edx,bms)/bms/bin/edx/edxnuc_g
/bms/bin/edx/edxstop
/bms/bin/edx/edxstart
%attr(4755,edx,bms)/bms/bin/edx/killterm
%attr(4755,edx,bms)/bms/bin/edx/whoterm
%config /bms/bin/haedx
/bms/bin/runedx
/bms/sbin/killtty
/bms/sbin/ckproc
/bms/bin/edx/runedx.py*
%config(noreplace) /bms/etc/runedx.conf
%dir /bms/etc/printers
%config %attr(-,root,root) /etc/logrotate.d/edx
%config(noreplace) %attr(0440,root,root) /etc/sudoers.d/edx
/edx
/var/log/edx
/bms/edx/mslib

%files devel
%defattr(-,edx,bms)
/bms/bin/edx/edxlink
/bms/bin/edx/ecc
/bms/bin/edx/edltr
/bms/bin/edx/edxsym
/bms/bin/edx/edxstring
/bms/bin/edx/utequ
/bms/lib/*
/bms/include/*
/bms/edx/edl.vim
/bms/edx/asm
/bms/edx/copycd
/bms/edx/lib/user

%changelog

* Wed Jan  3 2018 Stuart Gathman <stuart@gathman.org> 1.1.15-1
- New 64-bit clean source version 

* Thu Apr  7 2016 Stuart Gathman <stuart@gathman.org> 1.1.14-6
- Rebuild with btas-2.12

* Wed Mar 16 2016 Stuart Gathman <stuart@gathman.org> 1.1.14-5
- Build in mock for el7
- Clean up for 64-bit

* Thu May 16 2013 Stuart Gathman <stuart@bmsi.com> 1.1.14-4
- Userpid table in edxnuc

* Fri Mar 16 2012 Stuart Gathman <stuart@bmsi.com> 1.1.14-3
- Add edl.vim
- Port to CentOS-6

* Thu Mar 15 2012 Stuart Gathman <stuart@bmsi.com> 1.1.14-2
- Add system copycd to edx-devel

* Thu Mar 15 2012 Stuart Gathman <stuart@bmsi.com> 1.1.14-1
- Install BTREE2,MSLIB
- ecc enhancements
- disable BIGREC support

* Sun Mar 28 2010 Stuart Gathman <stuart@bmsi.com> 1.1.13-2
- Move rmiregistry startup to bmsi-edx

* Thu Mar 25 2010 Stuart Gathman <stuart@bmsi.com> 1.1.13-1
- Move javaterm, edxjava to bmsi-edx
- Single note mode for awcmed

* Tue Sep  8 2009 Stuart Gathman <stuart@bmsi.com> 1.1.12-1
- Add edxstart
- Increase key buffer to support large paste

* Tue May  5 2009 Stuart Gathman <stuart@bmsi.com> 1.1.11-1
- Fix late update of TCBS1 for CALLUSER

* Tue May  6 2008 Stuart Gathman <stuart@bmsi.com> 1.1.10-1
- tweaks for el5 compile

* Mon Feb 25 2008 Stuart Gathman <stuart@bmsi.com> 1.1.9-3
- edxnuc.x must be suid for ecc to work
- require edx-asm for ecc

* Mon Feb 18 2008 Stuart Gathman <stuart@bmsi.com> 1.1.9-2
- Fix unitialized max count for prog patch in diskut2.
- Fix edxlist for linked modules, add EDLPATH to edxdb.
- Show state and tty of EDX terms in edxmap.

* Sun Jun 10 2007 Stuart Gathman <stuart@bmsi.com> 1.1.9-1
- Add SETBAR termccall.

* Fri Apr 27 2007 Stuart Gathman <stuart@bmsi.com> 1.1.8-3
- Fix chkmail.c losing effective uid.
- Show errno on msgsnd failure.

* Tue Mar 20 2007 Stuart Gathman <stuart@bmsi.com> 1.1.8-2
- Remove suid from edxnuc.x, add seteuid to edxnuc (wrapnuc.c)
- Java2 support

* Tue Oct 31 2006 Stuart Gathman <stuart@bmsi.com> 1.1.8-1
- Fix esdid in edxsym
- Compile with latest C++
- chkmail improvements (issue33)
- reserve DEVKILL and killterm()

* Mon Nov 29 2004 Stuart Gathman <stuart@bmsi.com> 1.1.7-3
- Statically link EBCDIC table for edxbtas on AIX
- Configureable autoenable for EDX printers
- Fix runedx.sh autocancel

* Thu Oct 28 2004 Stuart Gathman <stuart@bmsi.com> 1.1.7-2
- Support old features in new config format.
- Go back to not reporting changed mail spool when empty

* Tue Oct 19 2004 Stuart Gathman <stuart@bmsi.com> 1.1.7-1
- build edxbtas from source - everything now built from source!

* Wed Sep 22 2004 Stuart Gathman <stuart@bmsi.com> 1.1.6-4
- convert edxc to STL
- build edxlink and development utilites from source

* Wed Sep 22 2004 Stuart Gathman <stuart@bmsi.com> 1.1.6-3
- fix loop in termio instructions after TERMERR exit
- Support new runedx.conf format

* Wed Sep 22 2004 Stuart Gathman <stuart@bmsi.com> 1.1.6-2
- make qmap work with /edx symlink
- move edximg to base package
- restart termio instructions when edx4978 not loaded
- support BREAK_ANY and edxmap in edxdb

* Tue Sep 21 2004 Stuart Gathman <stuart@bmsi.com> 1.1.6-1
- support STOPANY breakpoint
- new runedx config format - egb
- logrotate edxnuc.log

* Fri Jun 11 2004 Stuart Gathman <stuart@bmsi.com> 1.1.5-2
- include static libs and headers

* Fri Jun 11 2004 Stuart Gathman <stuart@bmsi.com> 1.1.5-1
- include edximg source

* Thu Jun 10 2004 Stuart Gathman <stuart@bmsi.com> 1.1.4-3
- include edxui source 
- include awcmed
- move edxdb to runtime
- report proper error when log file too big

* Tue Sep 02 2003 Stuart Gathman <stuart@bmsi.com> 1.1.4-2
- set gid in edxnuc wrapper

* Mon Aug 11 2003 Stuart Gathman <stuart@bmsi.com> 1.1.4-1
- include edcd

* Fri Aug 08 2003 Stuart Gathman <stuart@bmsi.com> 1.1.3-3
- include diskut2

* Tue May 13 2003 Stuart Gathman <stuart@bmsi.com> 1.1.3-2
- additional programs

* Fri Mar 28 2003 Stuart Gathman <stuart@bmsi.com> 1.1.3-1
- create edx user

* Wed Nov 08 2000 Stuart Gathman <stuart@bmsi.com> 1.1.2-1
- edxnuc not swapping opcode bytes for terminal CCALL
- include javaterm

* Tue Jul 18 2000 Stuart Gathman <stuart@bmsi.com>
- add manually compiled copies of essential utils to binary rpm (temporary)
- add permissions, and edxnuc wrapper

* Tue Jun  6 2000 Stuart Gathman <stuart@bmsi.com>
- initial release
